"use strict";
/**
 * Application Performance Monitoring (APM) Control Plane API
 * Provide a set of APIs for tenant to perform operations like create, update, delete and list APM domains, and also
work request APIs to monitor progress of these operations.

 * OpenAPI spec version: 20200630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.OperationTypes = void 0;
/**
 * Possibly types of operations that the work request may process.
 **/
var OperationTypes;
(function (OperationTypes) {
    OperationTypes["CreateApmDomain"] = "CREATE_APM_DOMAIN";
    OperationTypes["UpdateApmDomain"] = "UPDATE_APM_DOMAIN";
    OperationTypes["DeleteApmDomain"] = "DELETE_APM_DOMAIN";
    OperationTypes["GenerateDataKeys"] = "GENERATE_DATA_KEYS";
    OperationTypes["RemoveDataKeys"] = "REMOVE_DATA_KEYS";
    /**
     * This value is used if a service returns a value for this enum that is not recognized by this
     * version of the SDK.
     */
    OperationTypes["UnknownValue"] = "UNKNOWN_VALUE";
})(OperationTypes = exports.OperationTypes || (exports.OperationTypes = {}));
(function (OperationTypes) {
    function getJsonObj(obj) {
        return obj;
    }
    OperationTypes.getJsonObj = getJsonObj;
    function getDeserializedJsonObj(obj) {
        return obj;
    }
    OperationTypes.getDeserializedJsonObj = getDeserializedJsonObj;
})(OperationTypes = exports.OperationTypes || (exports.OperationTypes = {}));
//# sourceMappingURL=operation-types.js.map