/**
 * DevOps API
 * Use the DevOps APIs to create a DevOps project to group the pipelines,  add reference to target deployment environments, add artifacts to deploy,  and create deployment pipelines needed to deploy your software.
 * OpenAPI spec version: 20210630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Specifies load balancer traffic shift stage.
 */
export interface LoadBalancerTrafficShiftDeployStageSummary extends model.DeployStageSummary {
    "blueBackendIps": model.BackendSetIpCollection;
    "greenBackendIps": model.BackendSetIpCollection;
    /**
     * Specifies the target or destination backend set.
     */
    "trafficShiftTarget": string;
    "rolloutPolicy": model.LoadBalancerTrafficShiftRolloutPolicy;
    "loadBalancerConfig": model.LoadBalancerConfig;
    "rollbackPolicy"?: model.NoDeployStageRollbackPolicy | model.AutomatedDeployStageRollbackPolicy;
    "deployStageType": string;
}
export declare namespace LoadBalancerTrafficShiftDeployStageSummary {
    function getJsonObj(obj: LoadBalancerTrafficShiftDeployStageSummary, isParentJsonObj?: boolean): object;
    const deployStageType = "LOAD_BALANCER_TRAFFIC_SHIFT";
    function getDeserializedJsonObj(obj: LoadBalancerTrafficShiftDeployStageSummary, isParentJsonObj?: boolean): object;
}
